// XTPPropertyGridItemHotkey.cpp: Implementierung der Klasse CXTPPropertyGridItemHotkey.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "XTPPropertyGridItemHotkey.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// PropertyGridItemHotkey
//////////////////////////////////////////////////////////////////////

CXTPPropertyGridItemHotkey::CXTPPropertyGridItemHotkey(CString strCaption, DWORD hotkey, DWORD* pBindHotkey)
: CXTPPropertyGridItem(strCaption)
{
	m_nFlags = 0;
	m_wndHotkey.m_pItem = this;
	BindToHotkey(pBindHotkey);
	SetHotkey(hotkey);
}

CXTPPropertyGridItemHotkey::~CXTPPropertyGridItemHotkey()
{
}

void CXTPPropertyGridItemHotkey::OnSelect()
{
	CXTPPropertyGridItem::OnSelect();

	CRect rc = GetValueRect();
	rc.InflateRect(0, 3);
	if (!m_wndHotkey.m_hWnd) {
		m_wndHotkey.Create(WS_CHILD, rc, (CWnd*)m_pGrid, 0);
		m_wndHotkey.ModifyStyleEx(WS_EX_CLIENTEDGE, 0);
		m_wndHotkey.SetFont(GetGrid()->GetFont());
	}
	m_wndHotkey.MoveWindow(rc);	
	m_wndHotkey.SetHotKey((WORD)(m_hotkey & 0xff), (WORD)(m_hotkey >> 8));
	m_wndHotkey.ShowWindow(SW_SHOW);
	m_wndHotkey.SetFocus();
}

void CXTPPropertyGridItemHotkey::OnDeselect()
{
	CXTPPropertyGridItem::OnDeselect();

	if (m_wndHotkey.m_hWnd) m_wndHotkey.ShowWindow(SW_HIDE);
}

CString CXTPPropertyGridItemHotkey::HotkeyToString(DWORD hotkey)
{
	CString final;
	CString a;
	int modifier = (hotkey >> 8) & 0xff;
	if(modifier & HOTKEYF_CONTROL) {
		::GetKeyNameText(MapVirtualKey(VK_CONTROL, 0)<<16, a.GetBuffer(128), 128); a.ReleaseBuffer();
		final += a;
		final += " + ";
	}
	if(modifier & HOTKEYF_SHIFT) {
		::GetKeyNameText(MapVirtualKey(VK_SHIFT, 0)<<16, a.GetBuffer(128), 128); a.ReleaseBuffer();
		final += a;
		final += " + ";
	}
	if(modifier & HOTKEYF_ALT) {
		::GetKeyNameText(MapVirtualKey(VK_MENU, 0)<<16, a.GetBuffer(128), 128); a.ReleaseBuffer();
		final += a;
		final += " + ";
	}

	::GetKeyNameText((MapVirtualKey(hotkey & 0xff, 0)<<16) | (modifier & HOTKEYF_EXT ? (1<<24) : 0), a.GetBuffer(128), 128);
	a.ReleaseBuffer();

	final += a;

	if(final.GetLength() == 0)
		final = "(none)";

	return final;
}

void CXTPPropertyGridItemHotkey::SetHotkey(DWORD hotkey)
{
	m_hotkey = hotkey;

	if(m_pBindHotkey) {
		*m_pBindHotkey = m_hotkey;
	}
	CXTPPropertyGridItem::SetValue(HotkeyToString(m_hotkey));
}

DWORD CXTPPropertyGridItemHotkey::GetHotkey()
{
	return m_hotkey;
}

void CXTPPropertyGridItemHotkey::BindToHotkey(DWORD *pBindHotkey)
{
	m_pBindHotkey = pBindHotkey;
	if(m_pBindHotkey) {
		*m_pBindHotkey = m_hotkey;
	}
}
